3e27d7c1301ca9420eb93bfaa5774d32c12a57cf
[gnulib.git] / top / maint.mk
1 # -*-Makefile-*-
2 # This Makefile fragment tries to be general-purpose enough to be
3 # used by at least coreutils, idutils, CPPI, Bison, and Autoconf.
4
5 ## Copyright (C) 2001-2009 Free Software Foundation, Inc.
6 ##
7 ## This program is free software: you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation, either version 3 of the License, or
10 ## (at your option) any later version.
11 ##
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
15 ## GNU General Public License for more details.
16 ##
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program.  If not, see <http://www.gnu.org/licenses/>.
19
20 # This is reported not to work with make-3.79.1
21 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
22 ME := maint.mk
23
24 # Do not save the original name or timestamp in the .tar.gz file.
25 # Use --rsyncable if available.
26 gzip_rsyncable := \
27   $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null && echo --rsyncable)
28 GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
29
30 GIT = git
31 VC = $(GIT)
32 VC-tag = git tag -s -m '$(VERSION)'
33
34 VC_LIST = $(srcdir)/build-aux/vc-list-files
35
36 VC_LIST_EXCEPT = \
37   $(VC_LIST) | if test -f .x-$@; then grep -vEf .x-$@; else grep -v ChangeLog; fi
38
39 ifeq ($(origin prev_version_file), undefined)
40   prev_version_file = $(srcdir)/.prev-version
41 endif
42
43 PREV_VERSION := $(shell cat $(prev_version_file))
44 VERSION_REGEXP = $(subst .,\.,$(VERSION))
45 PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
46
47 ifeq ($(VC),$(GIT))
48 this-vc-tag = v$(VERSION)
49 this-vc-tag-regexp = v$(VERSION_REGEXP)
50 else
51 tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
52 tag-this-version = $(subst .,_,$(VERSION))
53 this-vc-tag = $(tag-package)-$(tag-this-version)
54 this-vc-tag-regexp = $(this-vc-tag)
55 endif
56 my_distdir = $(PACKAGE)-$(VERSION)
57
58 # Old releases are stored here.
59 release_archive_dir ?= ../release
60
61 # Prevent programs like 'sort' from considering distinct strings to be equal.
62 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
63 export LC_ALL = C
64
65 ## --------------- ##
66 ## Sanity checks.  ##
67 ## --------------- ##
68
69 # Collect the names of rules starting with `sc_'.
70 syntax-check-rules := $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
71                         $(srcdir)/$(ME) $(srcdir)/cfg.mk)
72 .PHONY: $(syntax-check-rules)
73
74 local-checks-available = \
75   $(syntax-check-rules) \
76   makefile-check
77 .PHONY: $(local-checks-available)
78
79 # Arrange to print the name of each syntax-checking rule just before running it.
80 $(syntax-check-rules): %: %.m
81 $(patsubst %, %.m, $(syntax-check-rules)):
82         @echo $(patsubst sc_%.m, %, $@)
83
84 local-check := $(filter-out $(local-checks-to-skip), $(local-checks-available))
85
86 syntax-check: $(local-check)
87 #       @grep -nE '#  *include <(limits|std(def|arg|bool))\.h>'         \
88 #           $$(find -type f -name '*.[chly]') &&                        \
89 #         { echo '$(ME): found conditional include' 1>&2;               \
90 #           exit 1; } || :
91
92 #       grep -nE '^#  *include <(string|stdlib)\.h>'                    \
93 #           $(srcdir)/{lib,src}/*.[chy] &&                              \
94 #         { echo '$(ME): FIXME' 1>&2;                                   \
95 #           exit 1; } || :
96 # FIXME: don't allow `#include .strings\.h' anywhere
97
98 # By default, _prohibit_regexp does not ignore case.
99 export ignore_case =
100 _ignore_case = $$(test -n "$$ignore_case" && echo -i || :)
101
102 # There are many rules below that prohibit constructs in this package.
103 # If the offending construct can be matched with a grep-E-style regexp,
104 # use this macro.  The shell variables "re" and "msg" must be defined.
105 define _prohibit_regexp
106   dummy=; : so we do not need a semicolon before each use;              \
107   test "x$$re" != x || { echo '$(ME): re not defined' 1>&2; exit 1; };  \
108   test "x$$msg" != x || { echo '$(ME): msg not defined' 1>&2; exit 1; };\
109   grep $(_ignore_case) -nE "$$re" $$($(VC_LIST_EXCEPT)) &&              \
110     { echo '$(ME): '"$$msg" 1>&2; exit 1; } || :
111 endef
112
113 sc_avoid_if_before_free:
114         @$(srcdir)/build-aux/useless-if-before-free                     \
115                 $(useless_free_options)                                 \
116             $$($(VC_LIST_EXCEPT)) &&                                    \
117           { echo '$(ME): found useless "if" before "free" above' 1>&2;  \
118             exit 1; } || :
119
120 sc_cast_of_argument_to_free:
121         @re='\<free *\( *\(' msg='don'\''t cast free argument'          \
122           $(_prohibit_regexp)
123
124 sc_cast_of_x_alloc_return_value:
125         @re='\*\) *x(m|c|re)alloc\>'                                    \
126         msg='don'\''t cast x*alloc return value'                        \
127           $(_prohibit_regexp)
128
129 sc_cast_of_alloca_return_value:
130         @re='\*\) *alloca\>' msg='don'\''t cast alloca return value'    \
131           $(_prohibit_regexp)
132
133 sc_space_tab:
134         @re='[ ]        ' msg='found SPACE-TAB sequence; remove the SPACE' \
135           $(_prohibit_regexp)
136
137 # Don't use *scanf or the old ato* functions in `real' code.
138 # They provide no error checking mechanism.
139 # Instead, use strto* functions.
140 sc_prohibit_atoi_atof:
141         @re='\<([fs]?scanf|ato([filq]|ll)) *\('                         \
142         msg='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q' \
143           $(_prohibit_regexp)
144
145 # Use STREQ rather than comparing strcmp == 0, or != 0.
146 sc_prohibit_strcmp:
147         @grep -nE '! *str''cmp *\(|\<str''cmp *\([^)]+\) *=='           \
148             $$($(VC_LIST_EXCEPT))                                       \
149           | grep -vE ':# *define STREQ\(' &&                            \
150           { echo '$(ME): use STREQ in place of the above uses of str''cmp' \
151                 1>&2; exit 1; } || :
152
153 # Using EXIT_SUCCESS as the first argument to error is misleading,
154 # since when that parameter is 0, error does not exit.  Use `0' instead.
155 sc_error_exit_success:
156         @grep -nE 'error \(EXIT_SUCCESS,'                               \
157             $$($(VC_LIST_EXCEPT) | grep -E '\.[chly]$$') &&             \
158           { echo '$(ME): found error (EXIT_SUCCESS' 1>&2; exit 1; } || :
159
160 # `FATAL:' should be fully upper-cased in error messages
161 # `WARNING:' should be fully upper-cased, or fully lower-cased
162 sc_error_message_warn_fatal:
163         @grep -nEA2 '[^rp]error \(' $$($(VC_LIST_EXCEPT))               \
164             | grep -E '"Warning|"Fatal|"fatal' &&                       \
165           { echo '$(ME): use FATAL, WARNING or warning' 1>&2;           \
166             exit 1; } || :
167
168 # Error messages should not start with a capital letter
169 sc_error_message_uppercase:
170         @grep -nEA2 '[^rp]error \(' $$($(VC_LIST_EXCEPT))               \
171             | grep -E '"[A-Z]'                                          \
172             | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' &&           \
173           { echo '$(ME): found capitalized error message' 1>&2;         \
174             exit 1; } || :
175
176 # Error messages should not end with a period
177 sc_error_message_period:
178         @grep -nEA2 '[^rp]error \(' $$($(VC_LIST_EXCEPT))               \
179             | grep -E '[^."]\."' &&                                     \
180           { echo '$(ME): found error message ending in period' 1>&2;    \
181             exit 1; } || :
182
183 sc_file_system:
184         @re=file''system ignore_case=1                                  \
185         msg='found use of "file''system"; spell it "file system"'       \
186           $(_prohibit_regexp)
187
188 # Don't use cpp tests of this symbol.  All code assumes config.h is included.
189 sc_prohibit_have_config_h:
190         @grep -n '^# *if.*HAVE''_CONFIG_H' $$($(VC_LIST_EXCEPT)) &&     \
191           { echo '$(ME): found use of HAVE''_CONFIG_H; remove'          \
192                 1>&2; exit 1; } || :
193
194 # Nearly all .c files must include <config.h>.
195 sc_require_config_h:
196         @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then               \
197           grep -L '^# *include <config\.h>'                             \
198                 $$($(VC_LIST_EXCEPT) | grep '\.c$$')                    \
199               | grep . &&                                               \
200           { echo '$(ME): the above files do not include <config.h>'     \
201                 1>&2; exit 1; } || :;                                   \
202         else :;                                                         \
203         fi
204
205 # You must include <config.h> before including any other header file.
206 sc_require_config_h_first:
207         @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then       \
208           fail=0;                                                       \
209           for i in $$($(VC_LIST_EXCEPT) | grep '\.c$$'); do             \
210             grep '^# *include\>' $$i | sed 1q                           \
211                 | grep '^# *include <config\.h>' > /dev/null            \
212               || { echo $$i; fail=1; };                                 \
213           done;                                                         \
214           test $$fail = 1 &&                                            \
215             { echo '$(ME): the above files include some other header'   \
216                 'before <config.h>' 1>&2; exit 1; } || :;               \
217         else :;                                                         \
218         fi
219
220 sc_prohibit_HAVE_MBRTOWC:
221         @re='\bHAVE_MBRTOWC\b' msg="do not use $$re; it is always defined" \
222           $(_prohibit_regexp)
223
224 # To use this "command" macro, you must first define two shell variables:
225 # h: the header, enclosed in <> or ""
226 # re: a regular expression that matches IFF something provided by $h is used.
227 define _header_without_use
228   h_esc=`echo "$$h"|sed 's/\./\\./g'`;                                  \
229   if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then              \
230     files=$$(grep -l '^# *include '"$$h_esc"                            \
231              $$($(VC_LIST_EXCEPT) | grep '\.c$$')) &&                   \
232     grep -LE "$$re" $$files | grep . &&                                 \
233       { echo "$(ME): the above files include $$h but don't use it"      \
234         1>&2; exit 1; } || :;                                           \
235   else :;                                                               \
236   fi
237 endef
238
239 # Prohibit the inclusion of assert.h without an actual use of assert.
240 sc_prohibit_assert_without_use:
241         @h='<assert.h>' re='\<assert *\(' $(_header_without_use)
242
243 # Prohibit the inclusion of getopt.h without an actual use.
244 sc_prohibit_getopt_without_use:
245         @h='<getopt.h>' re='\<getopt(_long)? *\(' $(_header_without_use)
246
247 # Don't include quotearg.h unless you use one of its functions.
248 sc_prohibit_quotearg_without_use:
249         @h='"quotearg.h"' re='\<quotearg(_[^ ]+)? *\(' $(_header_without_use)
250
251 # Don't include quote.h unless you use one of its functions.
252 sc_prohibit_quote_without_use:
253         @h='"quote.h"' re='\<quote(_n)? *\(' $(_header_without_use)
254
255 # Don't include this header unless you use one of its functions.
256 sc_prohibit_long_options_without_use:
257         @h='"long-options.h"' re='\<parse_long_options *\(' \
258           $(_header_without_use)
259
260 # Don't include this header unless you use one of its functions.
261 sc_prohibit_inttostr_without_use:
262         @h='"inttostr.h"' re='\<(off|[iu]max|uint)tostr *\(' \
263           $(_header_without_use)
264
265 # Don't include this header unless you use one of its functions.
266 sc_prohibit_error_without_use:
267         @h='"error.h"' \
268         re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
269           $(_header_without_use)
270
271 sc_prohibit_safe_read_without_use:
272         @h='"safe-read.h"' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
273           $(_header_without_use)
274
275 sc_prohibit_argmatch_without_use:
276         @h='"argmatch.h"' \
277         re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<argmatch(_exit_fn|_(in)?valid) *\()' \
278           $(_header_without_use)
279
280 sc_prohibit_root_dev_ino_without_use:
281         @h='"root-dev-ino.h"' \
282         re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
283           $(_header_without_use)
284
285 # Prohibit the inclusion of c-ctype.h without an actual use.
286 ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
287 |isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
288 sc_prohibit_c_ctype_without_use:
289         @h='[<"]c-ctype.h[">]' re='\<c_($(ctype_re)) *\(' $(_header_without_use)
290
291 _empty =
292 _sp = $(_empty) $(_empty)
293 # The following list was generated by running:
294 # man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
295 #   | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
296 _sig_functions = \
297   bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
298   sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
299   siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
300   sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
301 _sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
302 # The following were extracted from "man signal.h" manually.
303 _sig_types_and_consts =                                                 \
304   MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK           \
305   SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL            \
306   SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE    \
307   SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t  \
308   sigstack sigval stack_t ucontext_t
309 # generated via this:
310 # perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
311 _sig_names =                                                            \
312   SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT      \
313   SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL       \
314   SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP  \
315   SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR      \
316   SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS   \
317   SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1        \
318   SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW       \
319   SIGXCPU SIGXFSZ
320 _sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
321
322 # Prohibit the inclusion of signal.h without an actual use.
323 sc_prohibit_signal_without_use:
324         @h='<signal.h>'                                                 \
325         re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>'          \
326           $(_header_without_use)
327
328 sc_obsolete_symbols:
329         @re='\<(HAVE''_FCNTL_H|O''_NDELAY)\>'                           \
330         msg='do not use HAVE''_FCNTL_H or O'_NDELAY                     \
331           $(_prohibit_regexp)
332
333 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
334
335 # Each nonempty ChangeLog line must start with a year number, or a TAB.
336 sc_changelog:
337         @if $(VC_LIST_EXCEPT) | grep -l '^ChangeLog$$' >/dev/null; then \
338           grep -n '^[^12        ]'                                      \
339             $$($(VC_LIST_EXCEPT) | grep '^ChangeLog$$') &&              \
340           { echo '$(ME): found unexpected prefix in a ChangeLog' 1>&2;  \
341             exit 1; } || :;                                             \
342         fi
343
344 # Ensure that each .c file containing a "main" function also
345 # calls set_program_name.
346 sc_program_name:
347         @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then       \
348           files=$$(grep -l '^main *(' $$($(VC_LIST_EXCEPT) | grep '\.c$$')); \
349           grep -LE 'set_program_name *\(m?argv\[0\]\);' $$files         \
350               | grep . &&                                               \
351           { echo '$(ME): the above files do not call set_program_name'  \
352                 1>&2; exit 1; } || :;                                   \
353         else :;                                                         \
354         fi
355
356 # Require that the final line of each test-lib.sh-using test be this one:
357 # Exit $fail
358 # Note: this test requires GNU grep's --label= option.
359 sc_require_test_exit_idiom:
360         @if test -f $(srcdir)/tests/test-lib.sh; then                   \
361           die=0;                                                        \
362           for i in $$(grep -l -F /../test-lib.sh $$($(VC_LIST) tests)); do \
363             tail -n1 $$i | grep '^Exit \$$fail$$' > /dev/null           \
364               && : || { die=1; echo $$i; }                              \
365           done;                                                         \
366           test $$die = 1 &&                                             \
367             { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
368               echo 1>&2 'Exit $$fail';                                  \
369               exit 1; } || :;                                           \
370         fi
371
372 sc_the_the:
373         @re='\<the ''the\>'                                             \
374         ignore_case=1 msg='found use of "the ''the";'                   \
375           $(_prohibit_regexp)
376
377 sc_trailing_blank:
378         @re='[   ]$$'                                                   \
379         msg='found trailing blank(s)'                                   \
380           $(_prohibit_regexp)
381
382 # Match lines like the following, but where there is only one space
383 # between the options and the description:
384 #   -D, --all-repeated[=delimit-method]  print all duplicate lines\n
385 longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
386 sc_two_space_separator_in_usage:
387         @grep -nE '^   *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$'         \
388             $$($(VC_LIST_EXCEPT)) &&                                    \
389           { echo "$(ME): help2man requires at least two spaces between"; \
390             echo "$(ME): an option and its description";                \
391                 1>&2; exit 1; } || :
392
393 # Look for diagnostics that aren't marked for translation.
394 # This won't find any for which error's format string is on a separate line.
395 sc_unmarked_diagnostics:
396         @grep -nE                                                       \
397             '\<error \([^"]*"[^"]*[a-z]{3}' $$($(VC_LIST_EXCEPT))       \
398           | grep -v '_''(' &&                                           \
399           { echo '$(ME): found unmarked diagnostic(s)' 1>&2;            \
400             exit 1; } || :
401
402 # Avoid useless parentheses like those in this example:
403 # #if defined (SYMBOL) || defined (SYM2)
404 sc_useless_cpp_parens:
405         @grep -n '^# *if .*defined *(' $$($(VC_LIST_EXCEPT)) &&         \
406           { echo '$(ME): found useless parentheses in cpp directive'    \
407                 1>&2; exit 1; } || :
408
409 # Require the latest GPL.
410 sc_GPL_version:
411         @re='either ''version [^3]' msg='GPL vN, N!=3'                  \
412           $(_prohibit_regexp)
413
414 cvs_keywords = \
415   Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
416
417 sc_prohibit_cvs_keyword:
418         @re='\$$($(cvs_keywords))\$$'                                   \
419             msg='do not use CVS keyword expansion'                      \
420           $(_prohibit_regexp)
421
422 # Make sure we don't use st_blocks.  Use ST_NBLOCKS instead.
423 # This is a bit of a kludge, since it prevents use of the string
424 # even in comments, but for now it does the job with no false positives.
425 sc_prohibit_stat_st_blocks:
426         @re='[.>]st_blocks' msg='do not use st_blocks; use ST_NBLOCKS'  \
427           $(_prohibit_regexp)
428
429 # Make sure we don't define any S_IS* macros in src/*.c files.
430 # They're already defined via gnulib's sys/stat.h replacement.
431 sc_prohibit_S_IS_definition:
432         @re='^ *# *define  *S_IS'                                       \
433         msg='do not define S_IS* macros; include <sys/stat.h>'          \
434           $(_prohibit_regexp)
435
436 # Each program that uses proper_name_utf8 must link with
437 # one of the ICONV libraries.
438 sc_proper_name_utf8_requires_ICONV:
439         @progs=$$(grep -l 'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT)));\
440         if test "x$$progs" != x; then                                   \
441           fail=0;                                                       \
442           for p in $$progs; do                                          \
443             dir=$$(dirname "$$p");                                      \
444             base=$$(basename "$$p" .c);                                 \
445             grep "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \
446               || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
447           done;                                                         \
448           test $$fail = 1 &&                                            \
449             { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
450               exit 1; } || :;                                           \
451         fi
452
453 # Warn about "c0nst struct Foo const foo[]",
454 # but not about "char const *const foo" or "#define const const".
455 sc_redundant_const:
456         @re='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b'                \
457         msg='redundant "const" in declarations'                         \
458           $(_prohibit_regexp)
459
460 sc_const_long_option:
461         @grep '^ *static.*struct option ' $$($(VC_LIST_EXCEPT))         \
462           | grep -Ev 'const struct option|struct option const' && {     \
463               echo 1>&2 '$(ME): add "const" to the above declarations'; \
464               exit 1; } || :
465
466 NEWS_hash =                                                             \
467   $$(sed -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p'              \
468        $(srcdir)/NEWS                                                   \
469      | grep -v '^Copyright .*Free Software'                             \
470      | md5sum -                                                         \
471      | sed 's/ .*//')
472
473 # Ensure that we don't accidentally insert an entry into an old NEWS block.
474 sc_immutable_NEWS:
475         @if test -f $(srcdir)/NEWS; then                                \
476           test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : ||              \
477             { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
478         fi
479
480 # Update the hash stored above.  Do this after each release and
481 # for any corrections to old entries.
482 update-NEWS-hash: NEWS
483         perl -pi -e 's/^(old_NEWS_hash = ).*/$${1}'"$(NEWS_hash)/" \
484           $(srcdir)/cfg.mk
485
486 # Ensure that we use only the standard $(VAR) notation,
487 # not @...@ in Makefile.am, now that we can rely on automake
488 # to emit a definition for each substituted variable.
489 # We use perl rather than "grep -nE ..." to exempt a single
490 # use of an @...@-delimited variable name in src/Makefile.am.
491 makefile-check:
492         @perl -ne '/\@[A-Z_0-9]+\@/ && !/^cu_install_program =/'        \
493           -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}'    \
494             $$($(VC_LIST_EXCEPT) | grep -E '(^|/)Makefile\.am$$')       \
495           && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
496
497 news-date-check: NEWS
498         today=`date +%Y-%m-%d`;                                         \
499         if head NEWS | grep '^\*.* $(VERSION_REGEXP) ('$$today')'       \
500             >/dev/null; then                                            \
501           :;                                                            \
502         else                                                            \
503           echo "version or today's date is not in NEWS" 1>&2;           \
504           exit 1;                                                       \
505         fi
506
507 sc_makefile_TAB_only_indentation:
508         @grep -nE '^    [ ]{8}'                                         \
509             $$($(VC_LIST_EXCEPT) | grep -E 'akefile|\.mk$$')            \
510           && { echo '$(ME): found TAB-8-space indentation' 1>&2;        \
511                exit 1; } || :
512
513 sc_m4_quote_check:
514         @grep -nE '(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]'              \
515             $$($(VC_LIST_EXCEPT) | grep -E '(^configure\.ac|\.m4)$$')   \
516           && { echo '$(ME): quote the first arg to AC_DEF*' 1>&2;       \
517                exit 1; } || :
518
519 fix_po_file_diag = \
520 'you have changed the set of files with translatable diagnostics;\n\
521 apply the above patch\n'
522
523 # Verify that all source files using _() are listed in po/POTFILES.in.
524 po_file = po/POTFILES.in
525 sc_po_check:
526         @if test -f $(po_file); then                                    \
527           grep -E -v '^(#|$$)' $(po_file)                               \
528             | grep -v '^src/false\.c$$' | sort > $@-1;                  \
529           files=;                                                       \
530           for file in $$($(VC_LIST_EXCEPT)) lib/*.[ch]; do              \
531             test -r $$file || continue;                                 \
532             case $$file in                                              \
533               *.?|*.??) ;;                                              \
534               *) continue;;                                             \
535             esac;                                                       \
536             case $$file in                                              \
537             *.[ch])                                                     \
538               base=`expr " $$file" : ' \(.*\)\..'`;                     \
539               { test -f $$base.l || test -f $$base.y; } && continue;;   \
540             esac;                                                       \
541             files="$$files $$file";                                     \
542           done;                                                         \
543           grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files          \
544             | sort -u > $@-2;                                           \
545           diff -u -L $(po_file) -L $(po_file) $@-1 $@-2                 \
546             || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; };   \
547           rm -f $@-1 $@-2;                                              \
548         fi
549
550 # Sometimes it is useful to change the PATH environment variable
551 # in Makefiles.  When doing so, it's better not to use the Unix-centric
552 # path separator of `:', but rather the automake-provided `$(PATH_SEPARATOR)'.
553 msg = '$(ME): Do not use `:'\'' above; use $$(PATH_SEPARATOR) instead'
554 sc_makefile_path_separator_check:
555         @grep -nE 'PATH[=].*:'                                          \
556             $$($(VC_LIST_EXCEPT) | grep -E 'akefile|\.mk$$')            \
557           && { echo $(msg) 1>&2; exit 1; } || :
558
559 # Check that `make alpha' will not fail at the end of the process.
560 writable-files:
561         if test -d $(release_archive_dir); then :; else                 \
562           for file in $(distdir).tar.gz                                 \
563                       $(release_archive_dir)/$(distdir).tar.gz; do      \
564             test -e $$file || continue;                                 \
565             test -w $$file                                              \
566               || { echo ERROR: $$file is not writable; fail=1; };       \
567           done;                                                         \
568           test "$$fail" && exit 1 || : ;                                \
569         fi
570
571 v_etc_file = lib/version-etc.c
572 sample-test = tests/sample-test
573 texi = doc/$(PACKAGE).texi
574 # Make sure that the copyright date in $(v_etc_file) is up to date.
575 # Do the same for the $(sample-test) and the main doc/.texi file.
576 sc_copyright_check:
577         @if test -f $(v_etc_file); then                                 \
578           grep 'enum { COPYRIGHT_YEAR = '$$(date +%Y)' };' $(v_etc_file) \
579             >/dev/null                                                  \
580           || { echo 'out of date copyright in $(v_etc_file); update it' 1>&2; \
581                exit 1; };                                               \
582         fi
583         @if test -f $(sample-test); then                                \
584           grep '# Copyright (C) '$$(date +%Y)' Free' $(sample-test)     \
585             >/dev/null                                                  \
586           || { echo 'out of date copyright in $(sample-test); update it' 1>&2; \
587                exit 1; };                                               \
588         fi
589         @if test -f $(texi); then                                       \
590           grep 'Copyright @copyright{} .*'$$(date +%Y)' Free' $(texi)   \
591             >/dev/null                                                  \
592           || { echo 'out of date copyright in $(texi); update it' 1>&2; \
593                exit 1; };                                               \
594         fi
595
596 vc-diff-check:
597         $(VC) diff > vc-diffs || :
598         if test -s vc-diffs; then                               \
599           cat vc-diffs;                                         \
600           echo "Some files are locally modified:" 1>&2;         \
601           exit 1;                                               \
602         else                                                    \
603           rm vc-diffs;                                          \
604         fi
605
606 cvs-check: vc-diff-check
607
608 ALL_RECURSIVE_TARGETS += maintainer-distcheck
609 maintainer-distcheck:
610         $(MAKE) distcheck
611         $(MAKE) taint-distcheck
612         $(MAKE) my-distcheck
613
614
615 # Don't make a distribution if checks fail.
616 # Also, make sure the NEWS file is up-to-date.
617 ALL_RECURSIVE_TARGETS += vc-dist
618 vc-dist: $(local-check) cvs-check maintainer-distcheck
619         XZ_OPT=-9ev $(MAKE) dist
620
621 # Use this to make sure we don't run these programs when building
622 # from a virgin tgz file, below.
623 null_AM_MAKEFLAGS = \
624   ACLOCAL=false \
625   AUTOCONF=false \
626   AUTOMAKE=false \
627   AUTOHEADER=false \
628   MAKEINFO=false
629
630 built_programs = $$(cd src && MAKEFLAGS= $(MAKE) -s built_programs.list)
631
632 warn_cflags = -Dlint -O -Werror -Wall -Wformat -Wshadow -Wpointer-arith
633 bin=bin-$$$$
634
635 write_loser = printf '\#!%s\necho $$0: bad path 1>&2; exit 1\n' '$(SHELL)'
636
637 TMPDIR ?= /tmp
638 t=$(TMPDIR)/$(PACKAGE)/test
639 pfx=$(t)/i
640
641 # More than once, tainted build and source directory names would
642 # have caused at least one "make check" test to apply "chmod 700"
643 # to all directories under $HOME.  Make sure it doesn't happen again.
644 tp := $(shell echo "$(TMPDIR)/$(PACKAGE)-$$$$")
645 t_prefix = $(tp)/a
646 t_taint = '$(t_prefix) b'
647 fake_home = $(tp)/home
648
649 # Ensure that tests run from tainted build and src dir names work,
650 # and don't affect anything in $HOME.  Create witness files in $HOME,
651 # record their attributes, and build/test.  Then ensure that the
652 # witnesses were not affected.
653 ALL_RECURSIVE_TARGETS += taint-distcheck
654 taint-distcheck: $(DIST_ARCHIVES)
655         test -d $(t_taint) && chmod -R 700 $(t_taint) || :
656         -rm -rf $(t_taint) $(fake_home)
657         mkdir -p $(t_prefix) $(t_taint) $(fake_home)
658         GZIP=$(GZIP_ENV) $(AMTAR) -C $(t_taint) -zxf $(distdir).tar.gz
659         mkfifo $(fake_home)/fifo
660         touch $(fake_home)/f
661         mkdir -p $(fake_home)/d/e
662         ls -lR $(fake_home) $(t_prefix) > $(tp)/.ls-before
663         cd $(t_taint)/$(distdir)                        \
664           && ./configure                                \
665           && $(MAKE)                                    \
666           && HOME=$(fake_home) $(MAKE) check            \
667           && ls -lR $(fake_home) $(t_prefix) > $(tp)/.ls-after \
668           && diff $(tp)/.ls-before $(tp)/.ls-after      \
669           && test -d $(t_prefix)
670         rm -rf $(tp)
671
672 # Verify that a twisted use of --program-transform-name=PROGRAM works.
673 define install-transform-check
674   echo running install-transform-check                  \
675     && rm -rf $(pfx)                                    \
676     && $(MAKE) program_transform_name='s/.*/zyx/'       \
677       prefix=$(pfx) install                             \
678     && test "$$(echo $(pfx)/bin/*)" = "$(pfx)/bin/zyx"  \
679     && test "$$(find $(pfx)/share/man -type f|sed 's,.*/,,;s,\..*,,')" = "zyx"
680 endef
681
682 # Install, then verify that all binaries and man pages are in place.
683 # Note that neither the binary, ginstall, nor the ].1 man page is installed.
684 define my-instcheck
685   $(MAKE) prefix=$(pfx) install                         \
686     && test ! -f $(pfx)/bin/ginstall                    \
687     && { fail=0;                                        \
688       for i in $(built_programs); do                    \
689         test "$$i" = ginstall && i=install;             \
690         for j in "$(pfx)/bin/$$i"                       \
691                  "$(pfx)/share/man/man1/$$i.1"; do      \
692           case $$j in *'[.1') continue;; esac;          \
693           test -f "$$j" && :                            \
694             || { echo "$$j not installed"; fail=1; };   \
695         done;                                           \
696       done;                                             \
697       test $$fail = 1 && exit 1 || :;                   \
698     }
699 endef
700
701 define coreutils-path-check
702   {                                                     \
703     if test -f $(srcdir)/src/true.c; then               \
704       fail=1;                                           \
705       mkdir $(bin)                                      \
706         && ($(write_loser)) > $(bin)/loser              \
707         && chmod a+x $(bin)/loser                       \
708         && for i in $(built_programs); do               \
709                case $$i in                              \
710                  rm|expr|basename|echo|sort|ls|tr);;    \
711                  cat|dirname|mv|wc);;                   \
712                  *) ln $(bin)/loser $(bin)/$$i;;        \
713                esac;                                    \
714              done                                       \
715           && ln -sf ../src/true $(bin)/false            \
716           && PATH=`pwd`/$(bin)$(PATH_SEPARATOR)$$PATH   \
717                 $(MAKE) -C tests check                  \
718           && { test -d gnulib-tests                     \
719                  && $(MAKE) -C gnulib-tests check       \
720                  || :; }                                \
721           && rm -rf $(bin)                              \
722           && fail=0;                                    \
723     else                                                \
724       fail=0;                                           \
725     fi;                                                 \
726     test $$fail = 1 && exit 1 || :;                     \
727   }
728 endef
729
730 # Use -Wformat -Werror to detect format-string/arg-list mismatches.
731 # Also, check for shadowing problems with -Wshadow, and for pointer
732 # arithmetic problems with -Wpointer-arith.
733 # These CFLAGS are pretty strict.  If you build this target, you probably
734 # have to have a recent version of gcc and glibc headers.
735 # The hard-linking for-loop below ensures that there is a bin/ directory
736 # full of all of the programs under test (except the ones that are required
737 # for basic Makefile rules), all symlinked to the just-built "false" program.
738 # This is to ensure that if ever a test neglects to make PATH include
739 # the build srcdir, these always-failing programs will run.
740 # Otherwise, it is too easy to test the wrong programs.
741 # Note that "false" itself is a symlink to true, so it too will malfunction.
742 ALL_RECURSIVE_TARGETS += my-distcheck
743 my-distcheck: $(DIST_ARCHIVES) $(local-check)
744         $(MAKE) syntax-check
745         $(MAKE) check
746         -rm -rf $(t)
747         mkdir -p $(t)
748         GZIP=$(GZIP_ENV) $(AMTAR) -C $(t) -zxf $(distdir).tar.gz
749         cd $(t)/$(distdir)                              \
750           && ./configure --disable-nls                  \
751           && $(MAKE) CFLAGS='$(warn_cflags)'            \
752               AM_MAKEFLAGS='$(null_AM_MAKEFLAGS)'       \
753           && $(MAKE) dvi                                \
754           && $(install-transform-check)                 \
755           && $(my-instcheck)                            \
756           && $(coreutils-path-check)                    \
757           && $(MAKE) distclean
758         (cd $(t) && mv $(distdir) $(distdir).old        \
759           && $(AMTAR) -zxf - ) < $(distdir).tar.gz
760         diff -ur $(t)/$(distdir).old $(t)/$(distdir)
761         -rm -rf $(t)
762         @echo "========================"; \
763         echo "$(distdir).tar.gz is ready for distribution"; \
764         echo "========================"
765
766 WGET = wget
767 WGETFLAGS = -C off
768
769 rel-check:
770         tarz=/tmp/rel-check-tarz-$$$$; \
771         md5_tmp=/tmp/rel-check-md5-$$$$; \
772         set -e; \
773         trap 'status=$$?; rm -f $$tarz $$md5_tmp; exit $$status' 0 1 2 3 15; \
774         $(WGET) $(WGETFLAGS) -q --output-document=$$tarz $(url); \
775         echo "$(md5)  -" > $$md5_tmp; \
776         md5sum -c $$md5_tmp < $$tarz
777
778 rel-files = $(DIST_ARCHIVES)
779
780 gnulib-version = $$(cd $(gnulib_dir) && git describe)
781
782 announcement: NEWS ChangeLog $(rel-files)
783         @./build-aux/announce-gen                                       \
784             --release-type=$(RELEASE_TYPE)                              \
785             --package=$(PACKAGE)                                        \
786             --prev=$(PREV_VERSION)                                      \
787             --curr=$(VERSION)                                           \
788             --gpg-key-id=$(gpg_key_ID)                                  \
789             --news=NEWS                                                 \
790             --bootstrap-tools=autoconf,automake,bison,gnulib            \
791             --gnulib-version=$(gnulib-version)                          \
792             --no-print-checksums                                        \
793             $(addprefix --url-dir=, $(url_dir_list))
794
795 ## ---------------- ##
796 ## Updating files.  ##
797 ## ---------------- ##
798
799 ftp-gnu = ftp://ftp.gnu.org/gnu
800 www-gnu = http://www.gnu.org
801
802 # Use mv, if you don't have/want move-if-change.
803 move_if_change ?= move-if-change
804
805 emit_upload_commands:
806         @echo =====================================
807         @echo =====================================
808         @echo "$(srcdir)/build-aux/gnupload $(GNUPLOADFLAGS) \\"
809         @echo "    --to $(gnu_rel_host):$(PACKAGE) \\"
810         @echo "  $(rel-files)"
811         @echo '# send the /tmp/announcement e-mail'
812         @echo =====================================
813         @echo =====================================
814
815 noteworthy = * Noteworthy changes in release ?.? (????-??-??) [?]
816 define emit-commit-log
817   printf '%s\n' 'post-release administrivia' '' \
818     '* NEWS: Add header line for next release.' \
819     '* .prev-version: Record previous version.' \
820     '* cfg.mk (old_NEWS_hash): Auto-update.'
821 endef
822
823 .PHONY: alpha beta major
824 ALL_RECURSIVE_TARGETS += alpha beta major
825 alpha beta major: $(local-check) writable-files
826         test $@ = major                                         \
827           && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$' \
828                || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
829           || :
830         $(MAKE) vc-dist
831         $(MAKE) news-date-check
832         $(MAKE) -s announcement RELEASE_TYPE=$@ > /tmp/announce-$(my_distdir)
833         if test -d $(release_archive_dir); then                 \
834           ln $(rel-files) $(release_archive_dir);               \
835           chmod a-w $(rel-files);                               \
836         fi
837         $(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
838         echo $(VERSION) > $(prev_version_file)
839         $(MAKE) update-NEWS-hash
840         perl -pi -e '$$. == 3 and print "$(noteworthy)\n\n\n"' NEWS
841         $(emit-commit-log) > .ci-msg
842         $(VC) commit -F .ci-msg -a
843
844 .PHONY: web-manual
845 web-manual:
846         @test -z "$(manual_title)" \
847           && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
848         @cd '$(srcdir)/doc'; \
849           $(SHELL) ../build-aux/gendocs.sh -o '$(abs_builddir)/doc/manual' \
850              --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
851             "$(PACKAGE_NAME) - $(manual_title)"
852         @echo " *** Upload the doc/manual directory to web-cvs."
853
854 # Code Coverage
855
856 init-coverage:
857         $(MAKE) $(AM_MAKEFLAGS) clean
858         lcov --directory . --zerocounters
859
860 COVERAGE_CCOPTS ?= "-g --coverage"
861 COVERAGE_OUT ?= doc/coverage
862
863 build-coverage:
864         $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS)
865         $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check
866         mkdir -p $(COVERAGE_OUT)
867         lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \
868                 --capture
869
870 gen-coverage:
871         genhtml --output-directory $(COVERAGE_OUT) \
872                 $(COVERAGE_OUT)/$(PACKAGE).info \
873                 --highlight --frames --legend \
874                 --title "$(PACKAGE_NAME)"
875
876 coverage: init-coverage build-coverage gen-coverage
877
878 # Update gettext files.
879 PACKAGE ?= $(shell basename $(PWD))
880 PO_DOMAIN ?= $(PACKAGE)
881 POURL = http://translationproject.org/latest/$(PO_DOMAIN)/
882 PODIR ?= po
883 refresh-po:
884         rm -f $(PODIR)/*.po && \
885         echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
886         wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \
887         echo 'en@boldquot' > $(PODIR)/LINGUAS && \
888         echo 'en@quot' >> $(PODIR)/LINGUAS && \
889         ls $(PODIR)/*.po | sed 's/\.po//' | sed 's,$(PODIR)/,,' | sort >> $(PODIR)/LINGUAS
890
891 INDENT_SOURCES ?= $(C_SOURCES)
892 .PHONY: indent
893 indent:
894         indent $(INDENT_SOURCES)